/*******************************************
 *
 * Batteriemonitor
 *
 * (C) Fingers elektrische Welt 2010
 *
 *******************************************/
#include <p18cxxx.h>
#include <p18F452.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "defines.h"
#include "serial.h"
#include "i2c.h"

#pragma config OSC = HS
#pragma config STVR = ON
#pragma config WDTPS = 128
#pragma config WDT = ON
#pragma config BOR = ON
#pragma config BORV = 42

// >----- Mach mal Pause ---------<

#define	XTAL_FREQ	4MHZ		      // Jaja, ich WEISS dass das falsch ist *Grummel*                  
#define	MHZ	*1000			                            

#define	DelayUs(x)	{ unsigned int _dcnt; \
			  _dcnt = (x)/(12MHZ/(XTAL_FREQ))|1; \
			  while(--_dcnt != 0) \
				  continue; }



// >----- Mach mal Pause ---------<

// Diverses
char outpbuf [Buflen];                      // Ausgabepuffer;
volatile unsigned long Timerticks = 0;			// Systemticker alle 10ms

// Zeitmessung
volatile unsigned long SekundenTicker = 0;  // Systemticker jede Sekunde ++

// Messwerte
float Spannung = 0;
float Strom = 0;
int Temperatur = 0;

void main (void);
void InterruptHandlerHigh (void);

/**************************
 *
 * Systemticker erhhen
 *
 **************************/
void Systemticker (void)
 {
  Timerticks++;

  //-------------------------
  // Sekundenweise ausfhren
  //-------------------------
  if ((Timerticks % 100) == 0)
   {
    // Sekundenzhler
    SekundenTicker++;
   } // Von if ((Timerticks % 100) == 0)

 }

/**************************
 *
 * Systemticker auslesen
 *
 **************************/
long Get_Ticker (void)
 {
  return (Timerticks);
 }

/*************************************
 *
 * Verzgern im Millisekundenbereich
 *
 *************************************/
void Delayms (int time)
 {
  unsigned long ticker;

  ticker = Get_Ticker ();

  while ( (ticker + (time / 10)) > Get_Ticker () )
   {
    ClrWdt();    
   }
 }

//----------------------------------------------------------------------------
// High priority interrupt vector

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}


//----------------------------------------------------------------------------
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

void
InterruptHandlerHigh ()
{
   //--------------------
   // Timer 1 berlauf ?
   //--------------------
   if (PIR1bits.TMR1IF)
   	{

      Systemticker ();                                  // Systemticker erhhen

      PIR1bits.TMR1IF=0;                                         // Clear Interrupt-Flag

      // Werte fr 10 MHz
      TMR1L=0xCB;                                       // Timer 1 neu vorladen (0xF3CB = 10ms)
      TMR1H=0xF3;                                       // n = 2^16 - t [s] * 625000

   	} // From Timer 1 berlauf

   return;									                            // Zurck zum Hauptprogramm

}

/******************************
 *
 * Startklar machen den Eimer
 *
 ******************************/
void sysinit (void)
 {
  ClrWdt();

  //------------
  // Timer-Init
  //------------
  PIE1bits.TMR1IE=1;									                      // enable Interrupt of TMR1
  T1CON=49;									                      // Prescaler=1:8 + Timer on (49)
  INTCONbits.PEIE=1;          							                  // Peripherie Int=on
  INTCONbits.GIE=1;										                      // Define Interupts
  ClrWdt();

  //---------------------------------- 
  // Serielle Schnittstelle 9600 BPS
  //----------------------------------
  UART_Init ();
  
  //--------------------------
  // AD-Wandler-Einstellungen
  //--------------------------
  TRISA = 255;
  ADCON0bits.ADCS1 = 1;
  ADCON0bits.ADCS0 = 0;
  ADCON0bits.ADON = 1;             // Wandler ein
  ADCON1bits.ADFM = 1;             // Rechtsseitig

  ADCON1bits.PCFG3 = 0;            // Externe Referenz auf AN3, 
  ADCON1bits.PCFG2 = 0;
  ADCON1bits.PCFG1 = 1;
  ADCON1bits.PCFG0 = 1;

  i2c_init ();

 }

/***************************
 *
 * Wandlerwert reinlutschen
 *
 ***************************/
unsigned int ADCGetRaw (char channel)
 {
  //-----------------
  // Wo solls rein ?
  //-----------------
  if (channel == 0) {ADCON0bits.CHS2 = 0; ADCON0bits.CHS1 = 0; ADCON0bits.CHS0 = 0; }		// Strom 1 an AN0
  if (channel == 1) {ADCON0bits.CHS2 = 0; ADCON0bits.CHS1 = 0; ADCON0bits.CHS0 = 1; }		// Strom 2 an AN1
  if (channel == 2) {ADCON0bits.CHS2 = 0; ADCON0bits.CHS1 = 1; ADCON0bits.CHS0 = 0; }		// Spannung an AN2
  DelayUs (2000);  // Kondensator laden
  ADCON0bits.GO = 1;     // Los gehts
  while (ADCON0bits.GO);

  return (ADRES);
 }

/***************************************
 *
 * Hier geht das total los das Mopped !
 *
 ***************************************/
void main()
{
  float temp;
  float I1;
  float I2;
  int inttemp;
	
  sysinit ();

  // Mach das hier mal, bis du kotzen musst
  while (1)
   {
    ClrWdt();
	
    // Strom und Spannung ungekocht reinholen
    I1 = ADCGetRaw (0);
    I2 = ADCGetRaw (1);
    Strom = I1 + I2;
    Spannung = ADCGetRaw (2);

	// Temperatur reinholen
    INTCONbits.GIE = 0;   
    inttemp = i2c_ReadTemp (AdresseLM75);
    if ( (inttemp != -70) && (inttemp != 127) && (inttemp != 255) ) Temperatur = inttemp;
    INTCONbits.GIE = 1;   
   
    // Werte Testweise ausgeben
    /* 
    sprintf (outpbuf, "T=%5d ", (int)Temperatur);
    print (outpbuf); */

	// Umrechnungen in reale Werte
    temp = Spannung * 0.016;
    Spannung = temp + 0.4;
    Spannung *= 10;

    temp = 2 * Strom / 21;
    Strom = temp - 95.238;
    Strom *= 10;

    // Ausgabe begrenzen
    if (Spannung > 999) Spannung = 999;
	if (Strom > 999) Strom = 999;
    if (Strom < -999) Strom = -999;
//    if (Temperatur > 99) Temperatur = 99;
//    if (Temperatur < -99) Temperatur = -99;
	
   // Spannung
    sprintf (outpbuf, "U=%02d.%1dV ", (int)(Spannung / 10), (int)((int)Spannung % 10));
	print (outpbuf);

    // Strom
	if (Strom < 0)
     {
        sprintf (outpbuf, "I=-%02d.%1dA ", (int)((Strom / 10) * (-1)), (int)((int)(Strom * (-1) )% 10));
		print (outpbuf);
     } else
     {
	    sprintf (outpbuf, "I= %02d.%1dA ", (int)(Strom / 10), (int)((int)Strom % 10));
		print (outpbuf);
     }
 
    // Temperatur
	if (Temperatur < 0)
     {
        sprintf (outpbuf, "T=-%03dC", (int)(Temperatur * (-1)));
		print (outpbuf);
     } else
     {
	    sprintf (outpbuf, "T= %03dC ", (int)Temperatur);
		print (outpbuf);
     }

    sprintf (outpbuf, "\n\r");
	print (outpbuf);

    Delayms (100);

   } // Von While (1)

} // Thats all folks


