#include "serial.h"
#include "defines.h"
#include <p18cxxx.h>
#include <p18F452.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

/*****************************************************************************************************************
 *
 * String nach USART schreiben, nicht ISR-gesteuert
 *
 *****************************************************************************************************************/
void print (far const char *data)
{
  char cdummy;                                   // Dummyaufnahme des Empfangsregister

  if (RCSTAbits.FERR) cdummy = RCREG;
  if (RCSTAbits.OERR)
  	{
    	RCSTAbits.CREN=0;
    	RCSTAbits.CREN=1;
  	}
  	do
  	 {
  		while (!TXSTAbits.TRMT) ClrWdt();
    	TXREG = *data;
  	 } while ( *data++ );
}

/*****************************************************************************************************************
 *
 * Char nach USART schreiben, nicht ISR-gesteuert
 *
 *****************************************************************************************************************/
void put_char_usart (char data)
{
  char cdummy;                                   // Dummyaufnahme des Empfangsregister

  if (RCSTAbits.FERR) cdummy = RCREG;
  if (RCSTAbits.OERR)
  	{
    	RCSTAbits.CREN=0;
    	RCSTAbits.CREN=1;
  	}
   while (!TXSTAbits.TRMT) ClrWdt();
   TXREG = data;
}


/*****************************************************************************************************************
 *
 * UART initialisieren
 *
 *****************************************************************************************************************/
void UART_Init (void)
 {
  // UART-Einstellungen
  TRISC &= ~0b01000000;
  TRISC |=  0b10000000;
  SPBRG=64;       								                // USART: 9600 Baud bei 10MHZ - 8Bit-Mode mit BRGH=1
  TXSTA=0x24;									                    // mit BRGH=1
  RCSTA=0x90;
 }
